﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using System.Data.Services.Client;

namespace CustomActivities
{

    public sealed class GetOData<T> : AsyncCodeActivity<IEnumerable<T>>
    {
        [RequiredArgument]
        public InArgument<Uri> ServiceUrl { get; set; }
        public InArgument<string> EntitySetName { get; set; }

        protected override IAsyncResult BeginExecute(AsyncCodeActivityContext context, 
            AsyncCallback callback, object state)
        {
             DataServiceContext ctx = 
               new DataServiceContext(ServiceUrl.Get(context));

           DataServiceQuery<T> query = ctx.CreateQuery<T>(EntitySetName.Get(context));
           context.UserState = query;
           return query.BeginExecute(callback, state);
        }

        protected override IEnumerable<T> EndExecute(AsyncCodeActivityContext context, IAsyncResult result)
        {
            DataServiceQuery<T> query = context.UserState as DataServiceQuery<T>;
            return query.EndExecute(result);
        }
        
    }
}
