﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities.Persistence;
using System.Xml.Linq;

namespace CustomActivities
{
    public class UserWorkflowPersistenceParticipant : PersistenceParticipant
    {
        public static XNamespace nspace = XNamespace.Get("http://www.pluralsight.com/demos/wf");

        public static XName uName = nspace.GetName("userName");
        public static XName typeName = nspace.GetName("actTypeName");
        private string userName;
        private string activityType;


        protected override void CollectValues(out IDictionary<System.Xml.Linq.XName, object> readWriteValues, out IDictionary<System.Xml.Linq.XName, object> writeOnlyValues)
        {
            readWriteValues = new Dictionary<XName, object>{
                {uName, userName},
                {typeName, activityType}
            };

            writeOnlyValues = new Dictionary<XName,object>();


        }

        protected override void PublishValues(IDictionary<XName, object> readWriteValues)
        {
            userName = (string)readWriteValues[uName];
            activityType = (string)readWriteValues[typeName];
        }

        public void SetLookupValues(string user, string activity)
        {
            userName = user;
            activityType = activity;
        }

        
    }
}
