﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using FinancialAppWeb.Services;

namespace FinancialAppWeb.Filters
{
    public class WorkflowBookmarkFilter : ActionFilterAttribute
    {
        

        //public override void OnActionExecuted(ActionExecutedContext filterContext)
        //{
        //    throw new NotImplementedException();
        //}

        public override void OnActionExecuting(ActionExecutingContext filterContext)
        {
            string bookmark = WorkflowService.GetNextBookmark("ApplicationProcessing", filterContext.HttpContext.User.Identity.Name);

            if ((!String.IsNullOrEmpty(bookmark)) && string.Compare(filterContext.ActionDescriptor.ActionName, bookmark, true) != 0)
            {
                RouteValueDictionary routeValues =
                    new RouteValueDictionary();
                routeValues["controller"] = "Application";
                routeValues["action"] = bookmark;

                filterContext.Result = new RedirectToRouteResult(routeValues);
            }
        }

        
    }
}