﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Activities.Tracking;
using System.Net;
using System.Runtime.Serialization;
using System.Diagnostics;
using System.IO;

namespace FinancialAppWeb.Services
{
    public class CustomTrackingService : TrackingParticipant
    {
        protected override void Track(TrackingRecord record, TimeSpan timeout)
        {
            HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create("http://localhost:12670/FeedService.svc/records");
            request.Method = "POST";
            request.ContentType = "text/xml";

            DataContractSerializer serializer = 
                new DataContractSerializer(typeof(TrackingRecord),new List<Type>{typeof(ActivityStateRecord)});
            Stream s = request.GetRequestStream();
            
            serializer.WriteObject(s, record);
            s.Flush();
            s.Close();
            
            try
            {
                request.GetResponse();
            }
            catch (Exception ex)
            {
                Trace.WriteLine(ex.Message);
            }

                
        }

        public override TrackingProfile TrackingProfile
        {
            get
            {
                return new TrackingProfile
                {
                    ActivityDefinitionId = "*",
                    Queries =
                    {
                        new ActivityStateQuery{ActivityName = "ActivateUserAccount", 
                            Arguments = {"UserName"}, 
                            States = {"Closed"}
                        }
                    }
                };
            }
            set
            {
                base.TrackingProfile = value;
            }
        }
    }
}