﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Activities;
using System.Activities.DurableInstancing;
using System.Configuration;
using System.Runtime.DurableInstancing;
using System.Xml.Linq;


namespace FinancialAppWeb.Services
{
    public class WorkflowOwnerShipService
    {

        //static SqlWorkflowInstanceStore store;
       
        static InstanceOwner owner;
        static SqlWorkflowInstanceStore store;

        public static InstanceStore GetStore(Guid id )
        {
            if (store == null)
            {
                store =
                     new SqlWorkflowInstanceStore(
                         ConfigurationManager.ConnectionStrings["InstanceStore"].ConnectionString);

                store.Promote(Constants.PROMOTION_NAME,
                  new List<XName> {CustomActivities.UserWorkflowPersistenceParticipant.typeName,
                    CustomActivities.UserWorkflowPersistenceParticipant.uName}, null);
                store.InstanceCompletionAction = InstanceCompletionAction.DeleteAll;
                store.InstanceEncodingOption = InstanceEncodingOption.None;
                store.InstanceLockedExceptionAction = InstanceLockedExceptionAction.AggressiveRetry;


                InstanceHandle handle = null;

                handle = store.CreateInstanceHandle();

                InstanceView view = store.Execute(
                    handle, new CreateWorkflowOwnerCommand(), TimeSpan.FromSeconds(3));
                owner = view.InstanceOwner;
                store.DefaultInstanceOwner = view.InstanceOwner;
                
                handle.Free();
            }
            return store;
        }

        //public static void ReleaseStore()
        //{
        //    if (store != null)
        //    {
        //        store.Execute(handle,
        //            new DeleteWorkflowOwnerCommand(), TimeSpan.FromSeconds(30));
        //    }
        //}
        //public InstanceStore InstanceStore
        //{
        //    get { return store; }
        //}

        //public Guid WorkflowID
        //{
        //    get { return workflowInstanceID; }
        //}


       

     
    }
}